Google Play Music™ Desktop Player
=========================

[![Join the chat at https://gitter.im/MarshallOfSound/Google-Play-Music-Desktop-Player-UNOFFICIAL-](https://badges.gitter.im/Join%20Chat.svg)](https://gitter.im/MarshallOfSound/Google-Play-Music-Desktop-Player-UNOFFICIAL-?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)
[![Github All Releases](https://img.shields.io/github/downloads/MarshallOfSound/Google-Play-Music-Desktop-Player-UNOFFICIAL-/total.svg)](https://github.com/MarshallOfSound/Google-Play-Music-Desktop-Player-UNOFFICIAL-/releases)
 [![GitHub version](https://badge.fury.io/gh/MarshallOfSound%2FGoogle-Play-Music-Desktop-Player-UNOFFICIAL-.svg)](https://badge.fury.io/gh/MarshallOfSound%2FGoogle-Play-Music-Desktop-Player-UNOFFICIAL-)  [![Code Climate](https://codeclimate.com/github/MarshallOfSound/Google-Play-Music-Desktop-Player-UNOFFICIAL-/badges/gpa.svg)](https://codeclimate.com/github/MarshallOfSound/Google-Play-Music-Desktop-Player-UNOFFICIAL-) <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=23CZGASL6XMLJ" title="Help me out by donating to this project"><img src="https://img.shields.io/badge/paypal-donate-yellow.svg" alt="PayPal donate button" /></a>  
 Windows: [![Build status](https://ci.appveyor.com/api/projects/status/clg5vclqyltff7hg/branch/master?svg=true)](https://ci.appveyor.com/project/MarshallOfSound/google-play-music-desktop-player-unofficial/branch/master)  
 Max OSX: [![Build Status](https://travis-ci.org/MarshallOfSound/Google-Play-Music-Desktop-Player-UNOFFICIAL-.svg?branch=master)](https://travis-ci.org/MarshallOfSound/Google-Play-Music-Desktop-Player-UNOFFICIAL-)

![](http://samuel.ninja/img/gpmdp_screen.gif)

Run Google Play Music as a stand alone Desktop app.  Never again will you have to hunt through your tabs to pause your music, or stop listening to your favourite song because Chrome is guzzling up all your RAM..

Developed by [Samuel Attard][1].

No affiliation with Google. Google Play is a trademark of Google Inc.

[1]: https://www.samuelattard.com

Download
---------
Head over to our website http://www.googleplaymusicdesktopplayer.com to download the latest release for your platform.

OS Support
------------

* Windows 7 or later
* Mac OSX 10.8.0 or later
* Ubuntu 14.04 or later

**Note: We do not current have automated builds for Ubuntu (PR's are welcome)**

Features
--------

* Supports media keys (play, pause, stop, next, previous)
* [last.fm](https://www.last.fm) Scrobbling and Now Playing support!
* Hands free [Voice Controls](docs/VoiceControls.md)!
* Desktop notifications on track change
* A simplistic mini player
* Customizable Dark theme
* Task bar media controls (media controls embedded into the taskbar) *Windows only*
* Smooth scrolling and overlay scrollbars for a nicer User Experience
* HTML5 Audio Support - No more Adobe Flash Player :+1:
* Minimize to task bar for background music playing
* Customizable hotkeys, no worries if you don't have media keys.  Choose your own shortcuts
* Choose your audio output device from within the player
* And a whole lot more coming soon!

Integrating with GPMDP from External Applications
-------------------------------------------------
There are two methods you can use to integrate with GPMDP from an external application.  
1. [JSON Interface](docs/PlaybackAPI.md)  
2. [Web Socket Interface](docs/PlaybackAPI_WebSocket.md)  

Both are documented in the [Docs](docs) folder.  For one time read access you should
probably use the `JSON` interface.  For an application that requires continuous
updates as to the state of GPMDP or needs to control GPMDP you should use theme
`Web Socket` interface.


Development
-----------

To get started just pull the repo and run the following

```bash
npm install
npm start
```

To build the installers / release packages you need to run, you can only build a platforms installer from that platform.
```bash
# Windows
npm run make:win

# Mac OSX
npm run make:darwin
```

All releases will be signing with my Code Signing Certificates (Authenticode on Windows and Codesign on OSX)

Contributing
------------

If you find something wrong (theming issues, app crashes) please report them as an issue.  
If you think you can add something cool or fix a problem, fork the repo and make a pull request :D

**NOTE:** Some of the functionality in this app has been extracted into smaller submodules. In particular
* Google Play Music Interaction - https://github.com/gmusic-utils/gmusic.js
* Theming - https://github.com/gmusic-utils/gmusic-theme.js
* Mini Player - https://github.com/MarshallOfSound/gmusic-mini-player.js

Dev Requirements
----------------
* Node.js (Recommend `4.2.x`)

Continuous Integration
------------------------

We run tests and generate signed installers on two CI platforms
* Windows --> [AppVeyor][2]
* OSX --> [Travis CI][3]

You can download the latest signed installers for Windows from the artifacts section of AppVeyor  
You can download the latest signed package for OSX from the URL at the bottom of the build log on Travis CI

[2]: https://ci.appveyor.com/project/MarshallOfSound/google-play-music-desktop-player-unofficial
[3]: https://travis-ci.org/MarshallOfSound/Google-Play-Music-Desktop-Player-UNOFFICIAL-

License
-------

The MIT License (MIT)

Copyright (c) 2015 Samuel Attard

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
